#ifndef MCUA_H
#define MCUA_H
#ifdef __KERNEL__
	#include	"config.h"
#endif
#include	"version.h"
#include	"rsignal.h"
//   

//   

//   /  /

//  ioctl  mcua

#define RS_IOC_MAGIC			'k'
#define	RS_RESET				_IO(RS_IOC_MAGIC,0)
#define RS_BLNUMBER_RESET		_IO(RS_IOC_MAGIC,1)
#define	RS_GET_STATUS			_IOR(RS_IOC_MAGIC,2,0)
#define	RS_GET_VERS				_IOR(RS_IOC_MAGIC,3,0)
#define RS_GET_STATFIFO_SIZE	_IOR(RS_IOC_MAGIC,4,0)
#define RS_GET_DATAFIFO_SIZE	_IOR(RS_IOC_MAGIC,5,0)
#define RS_SET_BAUDRATE			_IOW(RS_IOC_MAGIC,6,0)

#define	CACHE_MAXSIZE	(0x80)	// if > CACHE_MAXSIZE => Signal

#ifdef __KERNEL__
	#ifdef __REAL_TIME__
		#include 	<rtl.h>
		#include 	<rtl_sched.h>
		#include	<rtl_fifo.h>
		#include	<rtl_time.h>
	#endif
	#include	<asm/atomic.h>
	#include	<linux/serial_reg.h>
	#include	<linux/sched.h>
	#include	"ipc.h"

	#ifdef __REAL_TIME__
		typedef hrtime_t		rs485_time_t;
	#else
		typedef struct timeval	rs485_time_t;
	#endif

/*  IPC device */
//VK	#define MAX_TASK_DEVICE		31
	#define MAX_TASK_DEVICE		32

	typedef struct _TASK_DEVICE_{ 			/*    */
		unsigned short		number; 		// 
		int 			round_count_prev;
	} TASK_DEVICE;

#endif

#include "success.h"

//     

#define 	RBYTE_WAIT		5		//	microseconds, ozhidanie baita 
#define		TBYTE_WAIT		5		//	microseconds (usec)
#ifdef __REAL_TIME__
	#define		RBYTE_TIMEOUT	500000L	//	nanosec = 500 mksec
	#define		TBYTE_TIMEOUT	500000L	//	nanosec = 500 mksec
#else
	#define		TBYTE_TIMEOUT	500		//	microseconds (usec)
	#define		RBYTE_TIMEOUT	500		//	microseconds (usec)
#endif

#ifdef __KERNEL__
/*   */

//	#define STREAM_STAT_FIFO	10		/*     mcua0 */
	#ifdef __REAL_TIME__
		#define STREAM_DINPUT_FIFO	12		/*    mcua0 */
	#endif

/*   */
	#define MASK_CNT_PACKET     0x60	/*     */
	#define MASK_ADR_PACKET     0X1F	/*    */

/*   ,  */
	#define FRECIVER			0		/*   */
	#define FTRANSMITTER 		1		/*   */
//	#define FCOLLISION			2		/*     */
//	#define FWAIT_TRANSMIT		3		/*    */
	#define FMCUA_OPEN 			4		/*   mcua*/
//	#define FBREAK_LINE 		6		/*   */
//	#define FUPDATE_READ		7		/*  update   proc */
	#define FREAD				7		/* FIFO reading */

/* */
	#define S_DATA_NAK			(0x8)
	#define S_FIFO_OVERFLOW		(0x40)

/*    */

	#define SWITCH_FAULT		0
	#define SWITCH_ADDRESSBYTE	1
	#define SWITCH_LENGTHBYTE	2
	#define SWITCH_DATABYTES	3
	#define SWITCH_REPLYBYTE	4
	#define SWITCH_OUTBYTES		6
	#define SWITCH_SIGNAL		5
	#define SWITCH_BADATA		7


/*     */

	#define RS485_MAJOR_LPT		28
	#define RS485_MAJOR_COM		29
	#define RS485_MAJOR_MOXA102	30
	#define RS485_MAJOR_MOXA132	31


/*    */
				//  
	#define FIRST       (UART_LCR_SPAR|UART_LCR_PARITY|UART_LCR_WLEN8)
				//   
	#define OTHER       (UART_LCR_SPAR|UART_LCR_EPAR|UART_LCR_PARITY|UART_LCR_WLEN8)


//#define	CACHE_MAXSIZE	36

struct _STACK_BUFFER_INP_ {
	unsigned char		cache[CACHE_MAXSIZE];
	unsigned char		size;
	unsigned char		adr;
	unsigned char		signature;
};

struct _OUT_BUFFER_ {
	unsigned char	cache[CACHE_MAXSIZE];
	unsigned char	size;	
};

#ifndef __REAL_TIME__
typedef struct _RS485_FIFO_ {
	char data_fifo[SIZE_STREAM_FIFO];
	volatile int data_wp;
	volatile int data_rp;
	atomic_t data_filled;		// skol'ko neschitannogo lezhit
	int nonblock;
#ifdef DECLARE_WAITQUEUE
	wait_queue_head_t	rs485_queue;
#else
	struct wait_queue	*rs485_queue;
#endif
} RS485FIFO;
#endif

typedef struct _RS485INFO_{
	long 				lFlags;			//   
	unsigned short		usCountByteInp; //   
	unsigned short		usCountByteOut; //   
	unsigned char		tmp_byte;		//  
	long				lSection;		//  
	unsigned short		signal;
	long				status;

	/*   */

	unsigned short		usHopInp;			//   
	unsigned short		usHopOut;			//   
	unsigned short		use_mcua;
    unsigned short      interface_type;     //VK  
	/* IO */

	unsigned short		base;
//	unsigned short		baud;
	int					baudrate;

	/*  */

	TASK_DEVICE					device[MAX_TASK_DEVICE];
	struct _STACK_BUFFER_INP_	active_inbuf;
	struct _STACK_BUFFER_INP_	passive_inbuf;
	struct _OUT_BUFFER_			outbuffer;
#ifndef __REAL_TIME__
	RS485FIFO					fifo;
#endif
} RS485INFO;

#endif

#endif
