#ifndef RS485_H
#define RS485_H

#ifdef __REAL_TIME__
	#include <rtl_printf.h>
#endif

#undef RS_PRINT
#ifdef __KERNEL__
	#ifdef __REAL_TIME__
		#define RS_PRINT(fmt,args...) rtl_printf(fmt, ## args)
	#else
		#define RS_PRINT(fmt,args...) printk(fmt, ## args)
	#endif
#else
	#define RS_PRINT(fmt, args...) fprintf(stderr, fmt, ##args)
#endif

#undef PDEBUG
#ifdef RS485_DEBUG
	#ifdef __KERNEL__
		#ifdef __REAL_TIME__
			#define PDEBUG(fmt,args...) rtl_printf(KERN_DEBUG "rs485: " fmt, ## args)
		#else
			#define PDEBUG(fmt,args...) printk(KERN_DEBUG "rs485: " fmt, ## args)
		#endif
	#else
		#define PDEBUG(fmt, args...) fprintf(stderr, fmt, ##args)
	#endif
#else
	#define PDEBUG(fmt, args...) // nothing...
#endif

#undef PDEBUGG
#define PDEBUGG(fmt, args...) // nothing...

#endif
