/************************************************************************
 *	    LPT-RS485 
 *		    moxa102_com
 *	
*************************************************************************/
#define __NO_VERSION__
#include <linux/config.h> 

 /*    */
#if CONFIG_MODVERSIONS==1
#include <linux/modversions.h>
#endif

#include <linux/module.h>

#include <linux/errno.h>
#include <linux/major.h>
#include <linux/delay.h>
#include <asm/io.h>
//#include <asm/atomic.h>

#include <linux/ioport.h>
#include <linux/parport.h>

#include <mcua.h>
#include <lpt.h>
#include <rs485.h>
#include <rserrno.h>

extern	int io1, io2;
extern	int irq1, irq2;
//extern	int portnumb;
//extern 	struct file_operations rs485_fops;

extern	void rs485_stop_interrupts(void);
extern	void rs485_allow_interrupts(void);

extern	int rs485_put_data(RS485INFO *info);

extern int iround(float a);
extern inline void rs485_gettime(rs485_time_t *tm);
extern inline void rs485_printtime(rs485_time_t *tm);
extern inline void rs485_printtm_interval(rs485_time_t *tm_start,
											rs485_time_t *tm_end);
extern inline int rs485_timeout(long interval);
extern inline void rs485_set_starttime(void);

extern void	rs485_fifo_flush(RS485INFO *info);

int start_transmitter(RS485INFO *info);

static volatile int data_ready = 0;
//static atomic_t	data_ready = ATOMIC_INIT(2);

int rs485_getIO(int port) {
	if(port==2) return _IO_LPT2;
	return _IO_LPT1;
}

int rs485_getIRQ(int port) {
	if(port==2) return _IRQ_LPT2;
	return _IRQ_LPT1;
}

/*
int rs485_init(void) {		//  
	int major = RS485_MAJOR;

	if(check_region(io, ADDRESS_REGION_SIZE)) {
		RS_PRINT( KERN_CRIT "%s: I/O port 0x%08lX in use.\n",
					ADAPTER_ID, (unsigned long) io);
		return( -EACCES);
	}
	request_region( io, ADDRESS_REGION_SIZE, ADAPTER_ID );
	
	if (register_chrdev (major, ADAPTER_ID, &rs485_fops)) {
		RS_PRINT( KERN_CRIT "%s: unable to get major %d\n", ADAPTER_ID, major);
		release_region( io, ADDRESS_REGION_SIZE );
		return (-EIO);
	}


	return(SUCCESS);
}
*/

inline void rs485_allow_interrupt_card(RS485INFO *pinfo) {
//   
	outb( inb(pinfo->base +EPP_CONTROL) | EPP_INT_ENABLE,
						pinfo->base +EPP_CONTROL );
}

inline void rs485_stop_interrupt_card(RS485INFO *pinfo) {
//   
	outb( inb(pinfo->base +EPP_CONTROL) & ~EPP_INT_ENABLE,
						pinfo->base +EPP_CONTROL );
}

inline void rs485_read_enable(RS485INFO *pinfo) {
#ifndef __OLD_LPT__
	outb( inb(pinfo->base +EPP_CONTROL) | ENABLE_BI_DIRECT,
						pinfo->base +EPP_CONTROL );
#else
	outb( (inb(pinfo->base +EPP_CONTROL) & ~ENABLE_BI_DIRECT) | 0x40,
						pinfo->base +EPP_CONTROL );
#endif
}

inline void rs485_transmit_enable(RS485INFO *pinfo) {
#ifndef __OLD_LPT__
	outb( inb(pinfo->base +EPP_CONTROL) & ~ENABLE_BI_DIRECT,
						pinfo->base +EPP_CONTROL );
#else
	outb( (inb(pinfo->base +EPP_CONTROL) & ~0x40) | ENABLE_BI_DIRECT,
						pinfo->base +EPP_CONTROL );
#endif
}

int rs485_probe(RS485INFO *pinfo);

#define Fosc		14746
#define Minbaudrate	115
#define Maxbaudrate 1840

int ubrr_to_rate(int baudrate_code) {
	int a;
	a = baudrate_code + 1;
	if(a == 0) return 0;
	return( baudrate_code == 0x80 ? Fosc/8 : Fosc/16/a );
}

int rate_to_ubrr(int baudrate) {
	int baudrate_code;
	baudrate = baudrate < Minbaudrate ? Minbaudrate : baudrate;
	baudrate = baudrate > Maxbaudrate ? Maxbaudrate : baudrate;
	baudrate_code = baudrate > 1200 ? 0x80 : iround(Fosc/16.0/baudrate)-1;
//VK       1800   -1 ( 0xFF ) 
//    
	return baudrate_code;
}

int rs485_set_baudrate(RS485INFO *pinfo) {
	int baudrate_code;
	baudrate_code = rate_to_ubrr(pinfo->baudrate);
	pinfo->baudrate = ubrr_to_rate(baudrate_code);
	PDEBUG("baudrate=%d baudrate_code=%d\n",pinfo->baudrate, baudrate_code);

    if( pinfo->interface_type == CONV_VERS1 ) {
 	udelay(10000);   
	    pinfo->outbuffer.size = 9;
	    pinfo->outbuffer.cache[pinfo->outbuffer.size] = 0;
	    pinfo->outbuffer.cache[0] = 0x1f;
	    pinfo->outbuffer.cache[1] = 0x07;
	    pinfo->outbuffer.cache[2] = 0x1f;
	    pinfo->outbuffer.cache[3] = 0x00;
	    pinfo->outbuffer.cache[4] = baudrate_code;
	    pinfo->outbuffer.cache[5] = 0x73;
	    pinfo->outbuffer.cache[6] = 0x00;
	    pinfo->outbuffer.cache[7] = 0x01;
	    pinfo->outbuffer.cache[8] = 0x6c;
	    start_transmitter(pinfo);
    }
    if( pinfo->interface_type == CONV_VERS2 ) {
        pinfo->outbuffer.size = 3;
        pinfo->outbuffer.cache[pinfo->outbuffer.size] = 0;
        pinfo->outbuffer.cache[0] = 0x1f;
        pinfo->outbuffer.cache[1] = 0x43;
        pinfo->outbuffer.cache[2] = baudrate_code;
  	    start_transmitter(pinfo);
    }
//	udelay(10000);
    return SUCCESS;
}

void rs485_reset(RS485INFO *pinfo) {
	int i;

	outb( EPP_TIMEOUT, pinfo->base +EPP_STATUS );		//  ?
	outb( 0, pinfo->base +EPP_CONTROL );                //   !!!
	udelay(EPP_WAIT);	// 250 mksec
	outb( EPP_RESET, pinfo->base +EPP_CONTROL );
	udelay(EPP_WAIT);	// 250 mksec

	outb( 0x0e, pinfo->base +EPP_DATA );
	outb( 0x1f, pinfo->base +EPP_ADDR );
	udelay(RESP_WAIT);	// 100 mksec
    i = inb(pinfo->base+EPP_DATA);
    if( i == SignalACN ) {
            // New code
        pinfo->interface_type = CONV_VERS2;
        outb( 0x87, pinfo->base +EPP_DATA ); //For new
        outb( 0x1f, pinfo->base +EPP_ADDR );
	    udelay(RESP_WAIT);	// 100 mksec
        i = inb(pinfo->base+EPP_DATA);
        PDEBUG("Converter code vers.2\n");
    } else {
        pinfo->interface_type = CONV_VERS1;
        PDEBUG("Converter code vers.1\n");
    }

		udelay(EPP_WAIT);

	rs485_read_enable(pinfo);
	pinfo->status = ACTIVE_DATA;
	rs485_allow_interrupt_card(pinfo);

	rs485_set_baudrate(pinfo);
	rs485_fifo_flush(pinfo);
}

inline int rs485_test_device(RS485INFO *pinfo) {

	unsigned short iir = inb(pinfo->base+EPP_STATUS);

	if( iir & PARPORT_STATUS_PAPEROUT ) {
		PDEBUG( "NO Converter!\n");
		return -ERSNOINTERFACE;
	}

	if( iir & PARPORT_STATUS_SELECT ) {
		PDEBUG( "NO POWER\n" );
		return -ERSSHUTDOWN;
	}

	if( iir & EPP_TIMEOUT ) {
		PDEBUG( "EPP TIMEOUT\n" );
		outb( EPP_TIMEOUT, pinfo->base +EPP_STATUS );
		return -ERSISATMOUT;
	}
	return(SUCCESS);
}


/*
inline int rs485_start(RS485INFO *pinfo) {
	int ret = 0;

	rs485_read_enable(pinfo);

//VK  test  reseta   ???

	if( (ret=rs485_test_device(pinfo)) < 0 ) return ret;

	pinfo->status = ACTIVE_DATA;

	rs485_allow_interrupt_card(pinfo);
	return(SUCCESS);
}
*/

int rs485_probe(RS485INFO *pinfo) {
//	unsigned short iir=0;
	u8 iir=0;
//	int i=0;
	int err=1;
	int resp_tmout=0;

	rs485_reset(pinfo);
	rs485_transmit_enable(pinfo);
	outb( 0x0e, pinfo->base +EPP_DATA );
	outb( 0x1f, pinfo->base +EPP_ADDR );
	rs485_read_enable(pinfo);

	rs485_set_starttime();
	resp_tmout = 0;
	while( 1 ) {
		if( ( (iir=inb(pinfo->base +EPP_STATUS)) & PARPORT_STATUS_ACK) != 0 ) break;
		if( rs485_timeout(RESP_TIMEOUT) ) {
			resp_tmout = 1;
			break;
		}
		udelay(RESP_WAIT);
	}
	if( resp_tmout ) return(err);
/*
	i=0;
	while( i<MAX_CYCLE_RESP_WAIT ) {
		iir = inb(pinfo->base +EPP_STATUS);
		if( (iir & PARPORT_STATUS_ACK) != 0 ) break;
		udelay(RESP_WAIT);
		i++;
	}
	if( i == MAX_CYCLE_RESP_WAIT ) return(err);
*/
	pinfo->tmp_byte = inb( pinfo->base +EPP_DATA );
	PDEBUGG( "probe: i=%d %x\n",i, pinfo->tmp_byte );

	//  -  "-"
	iir = inb(pinfo->base +EPP_STATUS);
	if( iir & EPP_TIMEOUT ) {
		PDEBUG( "probe: timeout!\n" );
		return(err);
	}
	if( (pinfo->tmp_byte == SignalACK)
		|| (pinfo->tmp_byte == SignalACN) ) return(SUCCESS);
	else return(err);
}
// -----------------------------------------------------------------------

int start_transmitter(RS485INFO *info) {
/* 
 *   
 *   < 0
 *  dlinu otveta, zapisannogo v info->....
*/
	int ready=0;
	int resp_tmout=0;

#ifdef __DEBUG_SIGNAL__
	outb(TXENABLE, 0x3f8 +UART_MCR);	// to COM1
#endif

//	atomc_set(&data_ready,2);
	data_ready = 0;	// not ready

	rs485_stop_interrupts();	// chtoby prochie handlery ne ustraivali mne pause
//	rs485_stop_interrupt_card(info);
	rs485_transmit_enable(info);
	up_flags(FTRANSMITTER, &info->lFlags);	//    

	info->usCountByteOut = 0;	//    0

	while( 1 ) {

		info->usCountByteOut ++;
		if( info->usCountByteOut >= info->outbuffer.size ) {
			info->status = PASSIVE_DATA;	//  ,  
										//   "" 
			break;
		}

		//    ( )
		outb(info->outbuffer.cache[info->usCountByteOut], // 1-, ,
				info->base +EPP_DATA);						//  

	}

	//   (     )
	outb( info->outbuffer.cache[0], info->base +EPP_ADDR );

//QUIT_TRANSMITTER:

	PDEBUGG( "send: %d bytes, QUIT\n",info->usCountByteOut );

	down_flags(FTRANSMITTER, &info->lFlags);
	rs485_allow_interrupts();
//	rs485_allow_interrupt_card(info);
	rs485_read_enable(info);

	//   

//    ,    

	rs485_set_starttime();
	resp_tmout = 0;
	while( 1 ) {

		rs485_stop_interrupts();	// protect race condition with handler
		ready = data_ready;
		rs485_allow_interrupts();

		if( ready ) break;
		if( rs485_timeout(RESP_TIMEOUT) ) {
			resp_tmout = 1;
			break;
		}
		udelay(RESP_WAIT);
	}

#ifdef __DEBUG_SIGNAL__
	outb(RXENABLE, 0x3f8 +UART_MCR);	// to COM1
#endif

	if( resp_tmout ) {
		PDEBUG( "transmit: timeout!\n" );
		return -ERSNOCONVREPLY;
	} else {
		return(info->passive_inbuf.size);
	}
}

inline void reciv_data(RS485INFO * info) {

/*
 * -----------------------------------------------------------
 *		   .
 *		  info->status == PASSIVE_DATA,    
 *		 .   : [length][data...]  [signal]
 *		  : [address][length][data...]
 * -----------------------------------------------------------
*/

	u8 iir = 0;
	unsigned char current_address = 0;
	struct _STACK_BUFFER_INP_ *current_inbuf;

#ifdef __DEBUG_TIMING__
	rs485_set_starttime();
#endif
	up_flags(FRECIVER, &info->lFlags);

//	rs485_stop_interrupts();			//   
										//   rtl_request_irq  ...

START:

#ifdef __DEBUG_SIGNAL__
	outb(TXENABLE, 0x3f8 +UART_MCR);	// to COM1
#endif

	// ,   -  
	iir = inb(info->base +EPP_STATUS);
	if( (iir & PARPORT_STATUS_ACK) == 0 ) {
//		if( first == 1 ) PDEBUG( "reciver: empty interrupt!\n" );
		goto QUIT_HANDLER;
	}

	info->signal = 0;
	info->usCountByteInp = 0; //   
	if( info->status == PASSIVE_DATA ) {
		current_inbuf = &(info->passive_inbuf);
		current_inbuf->size = 0;	// yesli ne smozhem nichego polozhit'
		info->lSection = SWITCH_LENGTHBYTE;
	} else {
		current_inbuf = &(info->active_inbuf);
		info->lSection = SWITCH_ADDRESSBYTE;
	}

	while( 1 ) {

		info->tmp_byte = inb( info->base +EPP_DATA );

		//  -  "-"
		iir = inb(info->base +EPP_STATUS);
		if( iir & EPP_TIMEOUT ) {

			PDEBUG( "reciver: timeout\n" );
			// reset:
			outb(EPP_TIMEOUT, info->base +EPP_STATUS);
			if( (iir & PARPORT_STATUS_ACK) == 0 ) {
				PDEBUG( "reciver: timeout: No data in converter\n" );
				goto QUIT_HANDLER;	// no data in converter
			}
			info->tmp_byte = inb( info->base +EPP_DATA );
			iir = inb(info->base +EPP_STATUS);
			if( iir & EPP_TIMEOUT ) {
				PDEBUG( "reciver: repeat. timeout, quit\n" );
				goto QUIT_HANDLER;
			}
		}

		switch(info->lSection) {

		case SWITCH_ADDRESSBYTE:

			if(info->status == PASSIVE_DATA ) {
				// Address or signal?
				if(info->tmp_byte > CACHE_MAXSIZE) {		// signal
					current_inbuf->size = info->tmp_byte;
					goto QUIT_HANDLER;
				}
			}

			current_inbuf->cache[info->usCountByteInp]
							= info->tmp_byte;
			info->usCountByteInp ++;

			//   
			current_address = info->tmp_byte;

			//      
			info->lSection = SWITCH_LENGTHBYTE;

			break;

		case SWITCH_LENGTHBYTE:

			//      ?
			if(info->status == PASSIVE_DATA ) {

				if(info->tmp_byte > CACHE_MAXSIZE) {	// signal
					current_inbuf->size = info->tmp_byte;
					data_ready = 1;
					info->status = ACTIVE_DATA;
					goto QUIT_HANDLER;
				}

			}
			if(info->tmp_byte >= 0x20) {
				PDEBUG( "reciver: length error!\n" );
				goto QUIT_HANDLER; //    
			}

			current_inbuf->cache[info->usCountByteInp]
										= info->tmp_byte;
			info->usCountByteInp ++;

			if( info->status == PASSIVE_DATA ) {
				current_inbuf->size = info->tmp_byte+1;
			} else {
				// +   
				current_inbuf->size = info->tmp_byte+2;
			}

			info->lSection = SWITCH_DATABYTES;

			break;

		case SWITCH_DATABYTES:			

			//  

			current_inbuf->cache[info->usCountByteInp]
										= info->tmp_byte;
			info->usCountByteInp ++;
			//       -   
			if( info->usCountByteInp < current_inbuf->size ) break;

			//  

			if( info->status == ACTIVE_DATA ) {

				//    FIFO

#ifdef __DEBUG_TIMING__
				if( rs485_timeout(1000L) ) {	// 1 millisecond = 1000 usec
					RS_PRINT( "Long packet: > 1 millisec!\n" );
				}
#endif

				if( current_address != current_inbuf->adr ) {
					current_inbuf->adr = current_address;
					rs485_put_data(info);
				} else {
					PDEBUG( "reciver: repeated packet!\n" );
				}

				goto TEST_REST;
			} else {

				//      

				data_ready = 1;
				info->status = ACTIVE_DATA;
				goto QUIT_HANDLER;
			}

		}
		if( (iir & PARPORT_STATUS_ACK) == 0 ) goto QUIT_HANDLER;	// no data in converter

	} //   

// debug
TEST_REST:
//	first=0;
	goto START;	// lovim rest

QUIT_HANDLER:

#ifdef __DEBUG_SIGNAL__
	outb(RXENABLE, 0x3f8 +UART_MCR);	// to COM1
#endif

//	rs485_allow_interrupts();			//  rtl_request_irq,   ...

	down_flags(FRECIVER, &info->lFlags);

	return;
}
