/************************************************************************
 *	  MOXA CP132
 *	
*************************************************************************/
#define __NO_VERSION__
#include <linux/config.h> 

/*    */
#if CONFIG_MODVERSIONS==1
#include <linux/modversions.h>
#endif

#include <linux/module.h>

#include <linux/errno.h>
#include <linux/major.h>
#include <linux/delay.h>
#include <asm/io.h>

#include <mcua.h>
#include <moxa132.h>
#include <rserrno.h>

#include <linux/ioport.h>

#include <rs485.h>

extern	int io1, io2;
extern	int irq1, irq2;
//extern	int portnumb;
//extern 	struct file_operations rs485_fops;

extern  inline void rs485_stop_interrupts(void);
extern  inline void rs485_allow_interrupts(void);

extern  char crc(unsigned char *buf, unsigned short size);
//extern	int _find_PCImoxa(void);
extern	int rs485_put_data(RS485INFO *info);

extern int iround(float a);
extern inline void rs485_gettime(rs485_time_t *tm);
extern inline void rs485_printtime(rs485_time_t *tm);
extern inline void rs485_printtm_interval(rs485_time_t *tm_start,
											rs485_time_t *tm_end);
extern inline int rs485_timeout(long interval);
extern inline void rs485_set_starttime(void);

extern void	rs485_fifo_flush(RS485INFO *info);

/*
int rs485_init(void) {		//  
	int res;
	int major = RS485_MAJOR;

	res = _find_PCImoxa();
	if(res < SUCCESS) return res;

	if( check_region( io, ADDRESS_REGION_SIZE ) ) {
		RS_PRINT( KERN_CRIT "%s: I/O port 0x%08lX in use.\n",
					ADAPTER_ID, (unsigned long) io);
		return(-EACCES);
	}
	request_region( io, ADDRESS_REGION_SIZE, ADAPTER_ID );
	
	if( register_chrdev (major, ADAPTER_ID, &rs485_fops) ) {
		RS_PRINT( KERN_CRIT "%s: unable to get major %d\n", ADAPTER_ID, major);
		release_region( io, ADDRESS_REGION_SIZE );
		return (-EIO);
	}

	return(SUCCESS);
}
*/

inline void rs485_allow_interrupt_card(RS485INFO *pinfo) {
//    
	outb(UART_IER_RDI, pinfo->base +UART_IER);
}

inline void rs485_stop_interrupt_card(RS485INFO *pinfo) {
//    
	outb(0, pinfo->base +UART_IER);
}

inline int rs485_test_device(RS485INFO *pinfo) {
	return 0;
}

inline void rs485_read_enable(RS485INFO *pinfo) {
	outb(UART_MCR_OUT2, pinfo->base +UART_MCR);	//   
}

inline void rs485_transmit_enable(RS485INFO *pinfo) {
	outb(UART_MCR_RTS, pinfo->base +UART_MCR);
}

inline void rs485_clean_reg(RS485INFO *pinfo) {
	unsigned short i;
	for(i=0; i<8; i++) outb(0x0, pinfo->base+i);
}

#define Fosc		14746
#define Minbaudrate	115
#define Maxbaudrate 921

int ubrr_to_rate(int baudrate_code) {
	if(baudrate_code == 0) return 0;
	return(Fosc/16/baudrate_code);
}

int rate_to_ubrr(int baudrate) {
	int baudrate_code;
	baudrate = baudrate < Minbaudrate ? Minbaudrate : baudrate;
	baudrate = baudrate > Maxbaudrate ? Maxbaudrate : baudrate;
	baudrate_code = iround(Fosc/16.0/baudrate);
	return baudrate_code;
}

int rs485_set_baudrate(RS485INFO *pinfo) {
	int baudrate_code = rate_to_ubrr(pinfo->baudrate);
	pinfo->baudrate = ubrr_to_rate(baudrate_code);
	outb( 0x80, pinfo->base +UART_LCR );	//  
	outw(baudrate_code, pinfo->base +UART_DLL); 
	outb(OTHER, pinfo->base +UART_LCR);	// .  
	return(SUCCESS);
}

void rs485_reset(RS485INFO *pinfo) {	//  -

	rs485_clean_reg(pinfo);

	rs485_read_enable(pinfo);
	rs485_allow_interrupt_card(pinfo);

	rs485_set_baudrate(pinfo);
	
	outb(UART_FCR_ENABLE_FIFO
					| UART_FCR_CLEAR_RCVR
					| UART_FCR_CLEAR_XMIT
					| UART_FCR_TRIGGER_8	//   fifo,
											//     - 
											//    1- 
					,pinfo->base +UART_FCR);  // fifo

//   
	inb( pinfo->base +UART_LSR );
	inb( pinfo->base +UART_RX );

	rs485_fifo_flush(pinfo);
}

/*
inline int rs485_start(RS485INFO *pinfo) {

	rs485_read_enable(pinfo);

	rs485_allow_interrupt(pinfo);

	return(SUCCESS);
}
*/

// -----------------------------------------------------------------------

int start_transmitter(RS485INFO *info) {
/*   
 *   < 0
 *   > CACHE_MAXSIZE
 *      < CACHE_MAXSIZE
*/
	unsigned  short iir=0;
	int ret=99;

	int rbyte_tmout=0;

	static int SharedMaskInterrupt;
	SharedMaskInterrupt = UART_LSR_TEMT;

	rs485_stop_interrupts();
//	rs485_stop_interrupt_card(info);
	up_flags(FTRANSMITTER, &info->lFlags);	//    

	outb(FIRST, info->base +UART_LCR);	// 
	rs485_transmit_enable(info);
	outb(info->outbuffer.cache[0], info->base); //   

	info->usHopOut = 0;	//  hop
	info->usHopInp = 0;	//  hop
	info->signal = 0;

	//   
	info->usCountByteOut = 0;	//    0
	info->usCountByteInp = 0;	//    0
	info->lSection = SWITCH_ADDRESSBYTE;	//   

	while( 1 ) {

		//  
		rs485_set_starttime();
		rbyte_tmout = 0;
		while( 1 ) {
			if( ( (iir=inb(info->base +UART_LSR)) & SharedMaskInterrupt ) != 0 ) break;
			if( rs485_timeout(TBYTE_TIMEOUT) ) {
				rbyte_tmout = 1;
				break;
			}
			udelay(TBYTE_WAIT);
		}


//       
		if( rbyte_tmout ) {

			switch(info->lSection) {

// no reply:
				case SWITCH_REPLYBYTE	:
					ret = SignalDSC;
									// no reply from module => disconnected
					PDEBUG( "transmit: timeout: no reply!\n" );
					goto QUIT_TRANSMITTER;

				case SWITCH_BADATA		:	//   bad-bytes,
											//  
					info->lSection = SWITCH_DATABYTES;
// data loss:
				case SWITCH_DATABYTES	:	//     
					(info->usHopInp) ++;	//   hop
					if(info->usHopInp < MAX_HOP) {
						info->signal = SignalNAK;
						PDEBUG( "transmit: broken packet!\n" );
						goto GOTO_SEND_SIGNAL;
					} else { 
						//  HOP   ACK   
						ret = SignalEER;
//						ret = -ERSTRANSMIT;	//    
						PDEBUG( "transmit: broken packet, MAX_HOP reached!\n" );
						goto QUIT_TRANSMITTER;
					}

				default	:	break;
			}
		}	// end of timeout-condition

		info->tmp_byte = inb(info->base);     //  

		if( (iir & UART_LSR_FE) != 0 ) {	//  .  , 
			PDEBUG( "transmit: frame error!\n" );

//			up_flags(FCOLLISION, &info->lFlags);
			switch(info->lSection) {

				case SWITCH_ADDRESSBYTE	:
				case SWITCH_SIGNAL		: 
					outb(OTHER, info->base +UART_LCR);	// . 
				case SWITCH_OUTBYTES	:
					rs485_read_enable(info);
				default: break;
			}
			ret = -ERSFRAME;
			goto QUIT_TRANSMITTER;
		}

		switch( info->lSection ) { //    
		
			case SWITCH_ADDRESSBYTE:

				//   
				//        OUTBYTES
				outb(OTHER, info->base +UART_LCR);
				info->lSection = SWITCH_OUTBYTES;

			case SWITCH_OUTBYTES:

				if( info->usCountByteOut == info->outbuffer.size ) {
					//   
					//    REPLYBYTE
					//   

					rs485_read_enable(info);
					SharedMaskInterrupt = UART_LSR_DR;

					info->lSection = SWITCH_REPLYBYTE;

				} else {

					//     
					(info->usCountByteOut) ++;
					outb(*(info->outbuffer.cache +info->usCountByteOut),
					 		info->base);
				}
				break;

			case SWITCH_REPLYBYTE: 

				//  

				if( iir  & UART_LSR_PE ) {	//  
					info->signal = info->tmp_byte;

// !!! Iz-za pomekh na linii vmesto ACY ingda prikhisit ACK, t.k. oni
// !!! otlochayutsia tol'ko odnim bitom.
// !!! Tut ACK ne mozhet byt', znachit, eto iskazhennyi ACY
//					if( info->signal == SignalACK ) info->signal = SignalACY;

					if( info->tmp_byte != (unsigned char) SignalNAK ) { 

						//     nak  
						//     
						ret = info->signal;
						goto QUIT_TRANSMITTER;

					} else {	//   nak

						PDEBUG( "transmit: NAK from module!\n" );
						info->usHopOut ++;
						if( info->usHopOut < MAX_HOP ){

							//       
							//   

							outb(FIRST, info->base +UART_LCR);	//  1- 
							rs485_transmit_enable(info);
							info->usCountByteOut = 0;
							SharedMaskInterrupt = UART_LSR_TEMT;
							info->lSection = SWITCH_ADDRESSBYTE;

							//  
							outb(info->outbuffer.cache[0], info->base);
							break;

						} else {

							//     

							ret = SignalNAK;
							goto QUIT_TRANSMITTER;
						}
					}

				} else { //    

					//  1   
					if( info->tmp_byte < (unsigned char)0x20 ) {

						info->passive_inbuf.size = info->tmp_byte +2;
						info->passive_inbuf.cache[info->usCountByteInp]=info->tmp_byte;
						info->lSection = SWITCH_DATABYTES;
						(info->usCountByteInp) ++;

					} else {
						PDEBUG( "transmit: bad length-byte, skipped!\n" );
						//     ,
						//    (NAK)
						info->lSection = SWITCH_BADATA;
					}
				}
				break;

			case SWITCH_BADATA:
				break;

			case SWITCH_DATABYTES: 
			
				//  

				info->passive_inbuf.cache[info->usCountByteInp] =
							info->tmp_byte; //    
				(info->usCountByteInp) ++;	

				if( info->usCountByteInp == info->passive_inbuf.size ) {

					//    -   
					if( crc(info->passive_inbuf.cache, 
							info->passive_inbuf.size) != 0 ) {

						//   
						PDEBUG( "transmit: bad CRC!\n" );
						(info->usHopInp) ++;	//   hop
						if(info->usHopInp == MAX_HOP) { 

							//  HOP  ACK   

							info->signal = SignalACK;
							ret = SignalEER;
//							ret = -ERSTRANSMIT;
													//  ?
						} else info->signal = SignalNAK; //   NAK
					} else { 
						//   
						//  ACK       

						info->signal = SignalACK;
						ret = info->passive_inbuf.size-1;	// size of data without CRC
					}
				}
				break;

			case  SWITCH_SIGNAL:

				//    
				//    

				outb(OTHER, info->base +UART_LCR);
				rs485_read_enable(info);

				if(info->signal == SignalNAK) {
					//     NAK,     
					info->signal = 0;
					info->lSection = SWITCH_REPLYBYTE;
					SharedMaskInterrupt = UART_LSR_DR;
					info->usCountByteInp = 0;
				} else {

					//  
					goto QUIT_TRANSMITTER;
				}
				break;

			default: break;

		}	//    

GOTO_SEND_SIGNAL:

		if( info->signal && (info->lSection == SWITCH_DATABYTES) ) {

			//    

			outb(FIRST, info->base +UART_LCR); //   
			rs485_transmit_enable(info);
			info->lSection = SWITCH_SIGNAL;
			SharedMaskInterrupt = UART_LSR_TEMT;
			outb(info->signal, info->base); 
		}

	}	//    

QUIT_TRANSMITTER:

	down_flags(FTRANSMITTER, &info->lFlags);
//	rs485_allow_interrupt_card(info);
	rs485_allow_interrupts();

	return ret;
}

inline void reciv_data(RS485INFO * info) {

/*
 * -----------------------------------------------------------
 *		  
 * ------------------------------------------------------------
*/

	int rbyte_tmout=0, iir=0;

#ifdef __DEBUG_TIMING__
	static rs485_time_t hand_start_prev;
	rs485_time_t		hand_start, hand_fin;
#endif

	unsigned char current_address = 0;
	static int SharedMaskInterrupt;
	SharedMaskInterrupt = UART_LSR_DR;


	up_flags(FRECIVER, &info->lFlags);


//	rs485_stop_interrupts();			//   
									//   rtl_request_irq  ...

	rs485_stop_interrupt_card(info);


#ifdef __DEBUG_SIGNAL__
	outb(TXENABLE, info->base +RX_TX_REG + 8);
#endif

#ifdef __DEBUG_TIMING__
	rs485_gettime(&hand_start);
	rs485_printtm_interval( &hand_start_prev, &hand_start );
	hand_start_prev = hand_start;
#endif

//	info->usHopInp = 0;
	info->signal = 0;
	info->lSection = SWITCH_ADDRESSBYTE;

	while( 1 ) {

//    
		rs485_set_starttime();
		rbyte_tmout = 0;
		while( 1 ) {
			iir = inb(info->base +UART_LSR);
			if( (iir & SharedMaskInterrupt) != 0 ) break;

			if( rs485_timeout(RBYTE_TIMEOUT) ) {
				rbyte_tmout = 1;
				break;
			}
			udelay(RBYTE_WAIT);
		}

//   - - 
		if( rbyte_tmout ) {
			PDEBUG( "reciver: time-out!\n" );
			if( info->lSection != SWITCH_SIGNAL ) goto QUIT_HANDLER;
		}

//  
		info->tmp_byte = inb(info->base);
//			PDEBUGG( "%X",info->tmp_byte );
			
//   ? 
		if( (iir & UART_LSR_FE) != 0 ) {
			PDEBUG( "reciver: frame error!\n" );
			goto QUIT_HANDLER;
		}

//   FIFO?
		if( (iir & UART_LSR_OE) != 0 ) {

			info->active_inbuf.signature |= S_FIFO_OVERFLOW;

			PDEBUG( "reciver: hard-FIFO overflow!\n" );

			//  FIFO
			outb( UART_FCR_ENABLE_FIFO | UART_FCR_CLEAR_RCVR
				| UART_FCR_CLEAR_XMIT
				| UART_FCR_TRIGGER_8	//   fifo,
										//     - 
										//    1- 
				,info->base +UART_FCR );

			goto QUIT_HANDLER;
		}

		switch( info->lSection ) {

		case SWITCH_ADDRESSBYTE:

			//        
			//   ,    (  :-))

			if( !(iir & UART_LSR_PE) ) {
				PDEBUG( "reciver: non address in address-section!\n" );
				goto QUIT_HANDLER;
			}

			//    - ,     
			if((unsigned char)(info->tmp_byte) >= (unsigned char) CACHE_MAXSIZE ){
				PDEBUG( "reciver: signal %x in address-section!\n",info->tmp_byte );
				goto QUIT_HANDLER;
			}

			//    
			if(info->active_inbuf.adr == info->tmp_byte) {

				PDEBUG( "reciver: repeated packet!\n" );
				//  ,    ,    ,
				//      
				// -      ...
				goto QUIT_HANDLER;
			}

			//   ,     
			info->usCountByteInp = 0;
			info->active_inbuf.cache[info->usCountByteInp]
					= info->tmp_byte;

			//   
			current_address = info->tmp_byte;
		                                                            
			//      
			info->usCountByteInp = 1;
			info->lSection = SWITCH_LENGTHBYTE;

			break;

		case SWITCH_LENGTHBYTE:

			//     or  - 
			if( iir & UART_LSR_PE ) {
				PDEBUG( "reciver: address or signal in length-section!\n" );
				goto QUIT_HANDLER;
			}

			//   ?
			if(info->tmp_byte >= 0x20) {
				PDEBUG( "reciver: length error!\n" );
				goto QUIT_HANDLER; //    
			}

			info->active_inbuf.cache[info->usCountByteInp]
					= info->tmp_byte;
			info->usCountByteInp ++;
			info->active_inbuf.size = info->tmp_byte+3;
			info->lSection = SWITCH_DATABYTES;

			break;

		case SWITCH_DATABYTES:			
			//  

			//     or  - 
			if( iir & UART_LSR_PE ) {
				PDEBUG( "reciver: address or signal in data-section!\n" );
				goto QUIT_HANDLER;
			}

			info->active_inbuf.cache[info->usCountByteInp]
					= info->tmp_byte;
			info->usCountByteInp ++;

			//       -   
			if( info->usCountByteInp < info->active_inbuf.size ) break;

			//    -     
			if( (crc(info->active_inbuf.cache,
				info->active_inbuf.size)) != 0 ) {

				PDEBUG( "reciver: bad CRC!\n" );
				if( (info->usHopInp) < MAX_HOP ) {
					//    hop- -  NAK    
					(info->usHopInp) ++;
					info->signal = SignalNAK;
					break;
				} else {
					//     hop-,     
					info->active_inbuf.signature |= S_DATA_NAK;
				}
			}

			info->usHopInp = 0;

			//  


			info->active_inbuf.adr = current_address;

			//    FIFO

			rs485_put_data(info);

			//    ACK
			info->signal = SignalACK;
			info->lSection = SWITCH_SIGNAL;

			break;

		case SWITCH_SIGNAL:

			rs485_read_enable(info);
			outb(OTHER, info->base +UART_LCR);	//    "  "
			SharedMaskInterrupt = UART_LSR_DR;

			if( ( iir & UART_LSR_PE ) !=0 ) {
				PDEBUG( "reciver: non signal in signal-sectiion!\n" );
			}

			//    ,     ...
			goto QUIT_HANDLER;

			break;

		}
		if( info->signal ) {
			//  
			outb(FIRST, info->base +UART_LCR);	//   "  "
			rs485_transmit_enable(info);
			outb(info->signal, info->base);
			info->lSection = SWITCH_SIGNAL;
			SharedMaskInterrupt = UART_LSR_TEMT;
		}
	} //   

QUIT_HANDLER:

	down_flags(FRECIVER,&info->lFlags);

#ifdef __DEBUG_TIMING__
	rs485_gettime(&hand_fin);
	rs485_printtm_interval( &hand_start, &hand_fin );
#endif

#ifdef __DEBUG_SIGNAL__
	outb(RXENABLE, info->base +RX_TX_REG + 8);
#endif

	rs485_allow_interrupt_card(info);
//	rs485_allow_interrupts(); 
						//   rtl_request_irq  ...

	return;
}
