/* -------------------------------------
 *     
 *  
 ---------------------------------------*/
 
#define __NO_VERSION__
 
#include <linux/config.h>
#include <asm/uaccess.h>
 
 /*    */
#if CONFIG_MODVERSIONS==1
#include <linux/modversions.h>
#endif
 
#include <linux/module.h>
#include <linux/errno.h>

#include <mcua.h>
#include <rtl_rs485_fifo.h>
#include <rs485.h>

int rs485_data_fifo_test( int count, RS485INFO *info ) {
// Sovmestimot' s ne RTL
	return 0;
}

int rs485_data_fifo_put( void* buf, int count, RS485INFO *info ) {
	return rtf_put( STREAM_DINPUT_FIFO, buf, count );
}

void rs485_fifo_flush(RS485INFO *info) {
	rtf_flush(STREAM_DINPUT_FIFO);
}

ssize_t rs485_data_fifo_read( RS485INFO* info, char* buf, size_t count ) {
	char buf0[CACHE_MAXSIZE];
	int ret = rtf_get( STREAM_DINPUT_FIFO, buf0, count );
	copy_to_user( buf, buf0, ret );
	return ret;
}

void rs485_fifo_init(struct file* file) {
	RS485INFO *info = file->private_data;
	rs485_fifo_flush(info);
}

int rs485_fifo_create(RS485INFO *info) {
	int err=0;

	rtf_destroy(STREAM_DINPUT_FIFO);
	if( (err=rtf_create(STREAM_DINPUT_FIFO, SIZE_STREAM_FIFO)) < 0 ) {
		RS_PRINT( KERN_CRIT "data-rtf_create error!\n");
		return err;
	}
	return(SUCCESS);
}

void rs485_fifo_destroy(void) {
	rtf_destroy(STREAM_DINPUT_FIFO);
}
