#define __NO_VERSION__
#include <linux/config.h>

/* IOII xOO IIOI */
#if CONFIG_MODVERSIONS==1
#include <linux/modversions.h>
#endif

#include <linux/module.h>
#include <rtl_time.h>

#include <mcua.h>
#include "rs485.h"

extern  inline void reciv_data(RS485INFO *info);
extern RS485INFO *info_port1;

static hrtime_t start_waiting = 0;

int iround(float a) {
	int i;
	if(a >= INT_MAX) return(INT_MAX);
	if(a <= INT_MIN) return(INT_MIN);
	i = (int) a;
	if(a < (float)i + 0.5) return i;
	return(i+1); 
}

inline void rs485_gettime(rs485_time_t *tm) {
	*tm = clock_gethrtime(CLOCK_REALTIME);
	return;
}

inline void rs485_printtime(rs485_time_t *tm) {
	RS_PRINT("rs485-time> %ld ns\n",(long)(*tm) );
}

inline void rs485_printtm_interval(rs485_time_t *tm_start,
								rs485_time_t *tm_end) {
	RS_PRINT("rs485-dtime> %ld ns\n", (long)(*tm_end - *tm_start) );
}

inline void rs485_set_starttime(void) {
	start_waiting = clock_gethrtime(CLOCK_REALTIME);
}

inline int rs485_timeout(long interval) {

// interval in nanosec

	if( ( clock_gethrtime(CLOCK_REALTIME) - start_waiting )
								> interval ) {
		PDEBUGG( "Timeout!!!\n" );
		return 1;
	} else return 0;
}

unsigned int rs485_interrupt( unsigned int irq, struct pt_regs *regs ) {

//    

	reciv_data(info_port1);

	rtl_hard_enable_irq(irq);
	return 0;
}

int rs485_request_irq(unsigned int irq) {
	int err=0;

	rtl_irqstate_t state;
	rtl_no_interrupts(state);
	if( (err=rtl_request_irq(irq, rs485_interrupt)) != 0 ) {
		RS_PRINT( KERN_CRIT "rs485: request_irq %d failed\n",irq );
	}
	rtl_hard_enable_irq(irq);
	rtl_restore_interrupts(state);
	return err;
}

void rs485_clean_irq(unsigned int irq) {
	rtl_irqstate_t state;
	rtl_no_interrupts(state);
	rtl_hard_disable_irq(irq);
	rtl_free_irq(irq);
	rtl_restore_interrupts(state);
}

inline void rs485_stop_interrupts(void) {
	rtl_stop_interrupts();
}

inline void rs485_allow_interrupts(void) {
	rtl_allow_interrupts();
}

