#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <pthread.h>
#include <signal.h>

#include "../include/mcua.h"

pthread_mutex_t lockmsg=PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t locktimer=PTHREAD_MUTEX_INITIALIZER;
static unsigned char msgbuf[80];
static int flags=0;
pthread_attr_t	atrib;
pthread_t		th_stat, th_timer;
static int id_mcua;
static int id_stat=0;
	
void * _Timer_clock (void *arg){
	while(1){
		pthread_mutex_lock(&locktimer);
		flags =0;
		sleep(60);
		if(pthread_mutex_trylock(&lockmsg) !=0){
			pthread_mutex_unlock(&locktimer);
			flags =1;
			pthread_mutex_unlock(&lockmsg);
		}
	}
pthread_exit(0);
}

void terminate_program(void){
	close(id_mcua);
	close(id_stat);
	
}

int main (int argc, char **argv){ 
	struct sched_param param;
	char	buf[80];

	int retval, yy;
	int count, i, sym;
	
	if (pthread_attr_init(&atrib) ==-1){	//  
		perror("Create attributes");
		exit(1);
	}
	param.sched_priority =10;				//   
	pthread_attr_setschedparam(&atrib, &param);
	pthread_attr_setschedpolicy(&atrib, PTHREAD_SCOPE_PROCESS);


	if((id_mcua =open("/dev/mcua0", O_RDWR))<0){ // 
		perror("Open mcua");
		exit(3);
	}

	id_stat = open("/dev/rtf10", O_RDONLY);

	ioctl(id_mcua,RS_BLNUMBER_RESET);


	atexit( terminate_program);
	
	if(argc <2){
		fprintf(stderr, "too few arguments\n");
		exit(4);
	}
	count =argc-1;
	while(1){
		for( i=0; i< count; i++){	//  
			sscanf(argv[i+1], "%X", &sym);
			buf[i] =sym;
		}
		retval =write( id_mcua, buf, count); // 
		printf("ret = %d\n", retval);
		if(retval <0){
		 	perror("txd: ");
			exit(0);
		}
		else if(retval >0x80){	// 
			printf("Signal : 0x%X\n", retval);
			exit(0);;
		}else{
			yy= read(id_stat, msgbuf, retval);
			for(i =0; i<yy; i++){
				printf("%X ", msgbuf[i]);
			}
			printf("\n");
		}
		exit(0);		
	}
exit(0);
}
