#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <pthread.h>
#include <signal.h>

#include "../include/mcua.h"

#define FLAGS_WAIT_STATUS	1
#define FLAGS_READ_BLOCK	2
#define FLAGS_DOUT_DATA 	4

pthread_mutex_t lockmsg  =PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t lockdata =PTHREAD_MUTEX_INITIALIZER;

static unsigned char msgbuf[40];
static unsigned char *msgdata;

pthread_attr_t	atrib;
pthread_t		th_stat, th_timer, th_data;
static int id_mcua;
static int id_out, id_stat=0;
static int id_data;
FILE	*fileinp;

const int counter = 0x1;


void *read_data(void *arg){ //  
	int size;
	int yy, t;
	
	printf("start read data...\n" );
	while(1){
//		pthread_mutex_lock(&lockdata);
		for(yy=0; yy<32;yy++){
			read(id_data, msgdata, 1);
			size = msgdata[0];
//			printf("size = %d\n", msgdata[0]);
			read(id_data, msgdata+1, size);
			for(t=0; t<=size;t++){
				printf("%02X ", msgdata[t]);
			}
			printf("\n");
			
		}
		pthread_mutex_unlock(&lockdata);
	}
pthread_exit(0);
}


void terminate_program(void){
	close(id_mcua);
	close(id_out);
	
	pthread_kill(th_data, SIGINT);
	pthread_join(th_data, NULL);
	pthread_mutex_destroy(&lockdata);
	free(msgdata);	
}

int main (int argc, char **argv){
	struct  sched_param param;
	char	buf[30];
	int retval, yy;
	int i;
	msgdata = (char *) malloc(4096);

	
	if (pthread_attr_init(&atrib) ==-1){	//  
		perror("Create attributes");
		exit(1);
	}	
	
	param.sched_priority =20;				//   
	pthread_attr_setschedparam(&atrib, &param);
	pthread_attr_setschedpolicy(&atrib, PTHREAD_SCOPE_PROCESS);
	if((id_mcua =open("/dev/mcua0", O_RDWR))<0){ // 
		perror("Open mcua");
		exit(3);
	}
	
	
	id_data = open("/dev/rtf12", O_RDONLY); 	// 
	pthread_mutex_lock(&lockdata);
	if(pthread_create(&th_data, &atrib, read_data, NULL) ==-1){
		perror("Create thread's");
		exit(2);
	}
	
	id_stat = open("/dev/rtf10", O_RDONLY); 	// 

	atexit( terminate_program);
	
	/*-------------------------------------- *
	 *    			 *
	 *-------------------------------------- */	
/*
		buf[0] = counter;
		buf[1] = 0x52;	// Set expos. 4 msec
		buf[1] = 0x65;	//
		buf[1] = 0xE;	//
		
		retval = write( id_mcua, buf, 4); // 
//		pthread_mutex_lock(&lockmsg);
		if(retval <0){
			perror("txd: ");
			exit(1);
		}else if( retval >0x80){
			printf("Signal : 0x%X\n", retval);
		}else {
			yy = read(id_stat, msgbuf, retval);
			for(i = 0; i<yy; i++){
				printf("%X ", msgbuf[i]);
			}
			printf("\n");
		}	 
*/	 
		buf[0] = counter;
		buf[1] = 0x8B;	// Induce off
		
		retval = write( id_mcua, buf, 2); // 
//		pthread_mutex_lock(&lockmsg);
		if(retval <0){
			perror("txd: ");
			exit(1);
		}else if( retval >0x80){
			printf("Signal : 0x%X\n", retval);
		}else {
			yy = read(id_stat, msgbuf, retval);
			for(i = 0; i<yy; i++){
				printf("%X ", msgbuf[i]);
			}
			printf("\n");
		}	 
	 
		buf[0] = counter;
		buf[1] = 0x83;	// Master on
		
		retval = write( id_mcua, buf, 2); // 
//		pthread_mutex_lock(&lockmsg);
		if(retval <0){
			perror("txd: ");
			exit(1);
		}else if( retval >0x80){
			printf("Signal : 0x%X\n", retval);
		}else {
			yy = read(id_stat, msgbuf, retval);
			for(i = 0; i<yy; i++){
				printf("%X ", msgbuf[i]);
			}
			printf("\n");
		}	 
	 
		buf[0] = counter;
		buf[1] = 0x88;	// Active on
		
		retval = write( id_mcua, buf, 2); // 
//		pthread_mutex_lock(&lockmsg);
		if(retval <0){
			perror("txd: ");
			exit(1);
		}else if( retval >0x80){
			printf("Signal : 0x%X\n", retval);
		}else {
			yy = read(id_stat, msgbuf, retval);
			for(i = 0; i<yy; i++){
				printf("%X ", msgbuf[i]);
			}
			printf("\n");
		}	 
	 
	 for( i=0; i<1; i++ ) {

		buf[0] = counter;
		buf[1] = 0x86;		
		retval = write( id_mcua, buf, 2); // 
						
		if(retval < 0){
			perror("txd: ");
			exit(1);
		}else if( retval > 0x80){
			printf("Signal : 0x%X\n", retval);
		}else {
			yy = read(id_stat, msgbuf, retval);
			for(i=0; i<yy; i++){
				printf("%02X ", msgbuf[i]);
			}
			printf("\n");
		}	 				
		pthread_mutex_lock(&lockdata);
	 
	 }
	 
exit(0);
}
