#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <pthread.h>
#include <signal.h>
#include <linux/errno.h>

#include "../include/mcua.h"
#include "../include/rserrno.h"

pthread_mutex_t lockmsg=PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t locktimer=PTHREAD_MUTEX_INITIALIZER;
//static unsigned char msgbuf[80];
static int flags=0;
pthread_attr_t	atrib;
pthread_t		th_stat, th_timer;
static int id_mcua=0;
static int id_stat=0;

extern int errno;	
void * _Timer_clock (void *arg){
	while(1){
		pthread_mutex_lock(&locktimer);
		flags =0;
		sleep(60);
		if(pthread_mutex_trylock(&lockmsg) !=0){
			pthread_mutex_unlock(&locktimer);
			flags =1;
			pthread_mutex_unlock(&lockmsg);
		}
	}
pthread_exit(0);
}

void terminate_program ( void ) {
	if( id_mcua > 0 ) close(id_mcua);
	if( id_stat > 0 ) close(id_stat);
}

int main (int argc, char **argv){ 
	struct sched_param param;
//	unsigned char	buf[80];
	unsigned char buf[CACHE_MAXSIZE];

	int retval;
	int count, i, sym;

	int verscode;
	char vers[100];
//	int rtl;
	
	if (pthread_attr_init(&atrib) ==-1) {	//  
		perror("Create attributes");
		exit(1);
	}
	param.sched_priority =10;				//   
	pthread_attr_setschedparam(&atrib, &param);
	pthread_attr_setschedpolicy(&atrib, PTHREAD_SCOPE_PROCESS);


	atexit( terminate_program);

	if( (id_mcua=open("/dev/mcua2", O_RDWR)) < 0 ) { // 
		printf( "Open mcua error: %s\n", rs_geterror(errno) );
		exit(3);
	}

	printf( "id_mcua=%d\n", id_mcua );

	verscode = ioctl( id_mcua, RS_GET_VERS,vers );
	printf( "driver:%s, ",vers );
//	rtl = RS485_RTL_CODE(verscode);

//	if(rtl) printf( "RTL version\n" );
//	else printf( "NON RTL version\n" );
/*
	if(rtl) {
		if( (id_stat=open("/dev/rtf10", O_RDONLY)) < 0 ) {
			perror("Open stat");
			exit(3);
		}
	}
*/

	ioctl( id_mcua, RS_BLNUMBER_RESET );

	
	if( argc < 2 ) {
		fprintf(stderr, "too few arguments\n");
		exit(4);
	}
	count = argc - 1;
	while(1) {
		for( i=0; i<count; i++) {	//   
			sscanf(argv[i+1], "%X", &sym);
			buf[i] = sym;
		}
		retval = write( id_mcua, buf, count );	//  
		printf("ret = %d\n", retval);
		if( retval < 0 ) {
			printf( "error: %s\n", rs_geterror(errno) );
			exit(0);
		} else if( retval > CACHE_MAXSIZE ) {
			printf( "Signal: %X\n", retval );
			exit(1);
		} else {
			for( i=1; i<retval; i++ ) {
				printf( " %X",buf[i] );
			}
			printf("\n");
			exit(0);		
		}
	}
exit(0);
}
