#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define F_SIZE	10

static char* fifo; //[F_SIZE];

static int w_pos;
static int r_pos;

int put_to_fifo(char* buf, int count) {
//	int a_pos;
//	int i;
	int rest;

	printf("write fifo %d %c\n",count, buf[0]);
	if( (w_pos+count-r_pos) > F_SIZE ) {
		printf( "!!! FIFO overflow! w_pos=%d r_pos=%d\n",
					w_pos, r_pos );
		return -1;
	}
/*
	for(i=w_pos; i<w_pos+count; i++) {
		a_pos =  i % F_SIZE;
		fifo[a_pos] = buf[i-w_pos];
	}
*/
// has fifo wrapped?
	if( w_pos+count < F_SIZE ) {  // not wrapped
		memcpy( fifo+w_pos, buf, count );
	} else {
		rest = F_SIZE-w_pos;
		memcpy( fifo+w_pos, buf, rest );   // not wrapped part
		memcpy( fifo, buf+rest, count-rest ); // wrapped part
	}
	w_pos += count;

	return count;
}

int read_fifo(char* buf, int count) {
//	int a_pos;
	int rest;

	printf("read %d counts: ",count);
	if( r_pos+count  > w_pos ) {
		printf( "read_fifo error!\n" );
		return 0;		
	}
/*
	for(i=r_pos; i<r_pos+count; i++) {
		a_pos =  i % F_SIZE;
//		printf("%c ",fifo[a_pos]);
		buf[i-r_pos] = fifo[a_pos];
		fifo[a_pos] = '0';
	}
*/
// has fifo wrapped?
	if( r_pos+count < F_SIZE ) {  // not wrapped
		memcpy( buf, fifo+r_pos, count );
	} else {
		rest = F_SIZE-r_pos;
		memcpy( buf, fifo+r_pos, rest );   // not wrapped part
		memcpy( buf+rest, fifo, count-rest ); // wrapped part
	}

	//	printf("\n");
	r_pos += count;
	if( r_pos >= F_SIZE ) {
		w_pos -= F_SIZE;
		r_pos -= F_SIZE;
	}
	return count;
}

void type_fifo(void) {
	int i;

	printf("w_pos=%d  r_pos=%d\n",w_pos,r_pos);
	for(i=0; i<F_SIZE; i++) {
		printf("%c ",fifo[i]);
	}
	printf("\n");
}

void type_buf(char *buf,int count) {
	int i;

	for(i=0; i<count; i++) {
		printf("%c ",buf[i]);
	}
	printf("\n");
}

void init_fifo(void) {
	int i;

	printf("init fifo\n");
	fifo = malloc( F_SIZE*sizeof(char) );
	w_pos=0; r_pos=0;
	for(i=0; i<F_SIZE; i++) {
		fifo[i] = '0';
	}
}

void close_fifo(void) {
	printf("close fifo\n");
	free(fifo);
}

int main() {
	char buf1[F_SIZE] = {'a','a','a','a','a','a','a','a','a','a'};
	char buf2[F_SIZE] = {'b','b','b','b','b','b','b','b','b','b'};
	char buf3[F_SIZE] = {'c','c','c','c','c','c','c','c','c','c'};
	char bufr[F_SIZE] = {'0','0','0','0','0','0','0','0','0','0'};

	printf("Test fifo: start...\n");

	init_fifo(); type_fifo();

	put_to_fifo(buf1,3); type_fifo();
	put_to_fifo(buf2,5); type_fifo();
	put_to_fifo(buf3,1); type_fifo();
	read_fifo(bufr,2); type_buf(bufr,2); type_fifo();
	put_to_fifo(buf2,2); type_fifo();

	read_fifo(bufr,3); type_buf(bufr,3); type_fifo();
	read_fifo(bufr,5); type_buf(bufr,5); type_fifo();
	read_fifo(bufr,2); type_buf(bufr,2); type_fifo();

	put_to_fifo(buf1,7); type_fifo();
	read_fifo(bufr,7); type_buf(bufr,7); type_fifo();

	close_fifo();

	printf("Test fifo: finished\n");
	exit(1);
}
